﻿#include <algorithm>
#include <climits>
#include <cmath>
#include <deque>
#include <iostream>
#include <set>
#include <tuple>
#include <queue>

#define int long long
#define INF INT_MAX
#define opt ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL)

using namespace std;

int32_t main() {
	opt;
	int n, m, k;
	cin >> n >> m >> k;

	deque<tuple<int, int>> edges(m);
	for (int i = 0; i < m; ++i) {
		cin >> get<0>(edges[i]) >> get<1>(edges[i]);
		get<0>(edges[i])--;
		get<1>(edges[i])--;
	}

	deque<pair<int, int>> guards(k);
	for (int i = 0; i < k; ++i) {
		cin >> guards[i].first >> guards[i].second;
		guards[i].first--;
	}

	deque<bool> protected_warehouses(n, false);

	for (int i = 0; i < k; ++i) {
		int guard_warehouse = guards[i].first;
		int guard_endurance = guards[i].second;

		queue<pair<int, int>> q;
		q.push({ guard_warehouse, 0 });
		deque<bool> visited(n, false);
		visited[guard_warehouse] = true;

		while (!q.empty()) {
			int u = q.front().first;
			int dist = q.front().second;
			q.pop();

			if (dist <= guard_endurance) {
				protected_warehouses[u] = true;
			}

			for (const auto& edge : edges) {
				int v = -1;
				if (get<0>(edge) == u && !visited[get<1>(edge)]) {
					v = get<1>(edge);
				}
				else if (get<1>(edge) == u && !visited[get<0>(edge)]) {
					v = get<0>(edge);
				}
				if (v != -1) {
					q.push({ v, dist + 1 });
					visited[v] = true;
				}
			}
		}
	}

	deque<int> answer;
	for (int i = 0; i < n; ++i) {
		if (protected_warehouses[i]) {
			answer.push_back(i + 1);
		}
	}
	cout << answer.size() << "\n";
	for (auto& i : answer) {
		cout << i << " ";
	}
}